package com.learning.datagen;

import com.learning.Learning;
import com.learning.block.CustomBlocks;
import com.learning.item.CustomItems;
import net.fabricmc.fabric.api.client.datagen.v1.provider.FabricModelProvider;
import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.minecraft.block.Block;
import net.minecraft.client.data.*;
import net.minecraft.util.Identifier;

public class ModModelProvider extends FabricModelProvider {
    public ModModelProvider(FabricDataOutput output) {
        super(output);
    }

    public TextureMap blockOnlySideTop(Block block) {
        return new TextureMap()
                .put(TextureKey.TOP, ModelIds.getBlockSubModelId(block, "_top"))
                .put(TextureKey.BOTTOM, Identifier.of(Learning.MOD_ID, "block/white_block_bottom"))
                .put(TextureKey.SIDE, ModelIds.getBlockSubModelId(block, "_side"));
    }

    @Override
    public void generateBlockStateModels(BlockStateModelGenerator blockStateModelGenerator) {
        blockStateModelGenerator.registerSingleton(CustomBlocks.damageBlock, TexturedModel.makeFactory(this::blockOnlySideTop, Models.CUBE_BOTTOM_TOP));
        blockStateModelGenerator.registerSingleton(CustomBlocks.transformBlock, TexturedModel.makeFactory(this::blockOnlySideTop, Models.CUBE_BOTTOM_TOP));
    }

    @Override
    public void generateItemModels(ItemModelGenerator itemModelGenerator) {
        itemModelGenerator.register(CustomItems.overcookedToast, Models.GENERATED);
        itemModelGenerator.register(CustomItems.bakedToast, Models.GENERATED);
        itemModelGenerator.register(CustomItems.toast, Models.GENERATED);
    }

    @Override
    public String getName() {
        return "FabricDocsReference Model Provider";
    }
}
